/**
 * 
 */
package de.hwrBerlin.hwrchat.model.messages;

/**
 * @author Benjamin Pfeiffer
 * 
 *         Diese Message soll gesendet werden, wenn der Client versucht sich einzuloggen.
 *         Das Sender Attribut muss dann die Login-Information enthalten.
 *         Der Server wertet diese Infomartionen aus, bei Erfolg wird das Empfnger-Attribut
 *         mit dem User-Objekt der Datenstruktur verknpft. Falls nicht ist es null, eine 
 *         Error Message wird mitgegeben.
 *         
 */
public class ConnectionRequestMessage extends AMessage {
    
	private String _errorMessage;

	

	/**
     * @return the errorMessage
     */
    public String getErrorMessage() {
        return _errorMessage;
    }



    /**
     * @param pErrorMessage the errorMessage to set
     */
    public void setErrorMessage(String pErrorMessage) {
        _errorMessage = pErrorMessage;
    }



    //Dieses Feld wird ignoriert, da diese Message auch wieder an den Clienten gesendet werden soll
	@Override
	public boolean toServer() {
		// TODO Auto-generated method stub
		return true;
	}
	
    
}
