/**
 * 
 */
package de.hwrBerlin.hwrchat.model.messages;

import java.util.List;

import de.hwrBerlin.hwrchat.model.User;

/**
 * @author Benjamin Pfeiffer
 * 
 *         Diese Message soll vom Client an den Server geschickt werden,
 *         wenn alle User aufgelistet werden sollen (z.B. beim Finden von Freunden)
 *         Der Server kann dann alle User in das Attribut _allUsers schreiben.
 *         
 */
public class GetAllUsersRequestMessage extends AMessage {
    
	private List<User> _allUsers;

	public List<User> getAllUsers() {
		return _allUsers;
	}

	public void setAllUsers(List<User> pAllUsers) {
		_allUsers = pAllUsers;
	}


	//Dieses Feld wird ignoriert, da diese Message auch wieder an den Clienten gesendet werden soll
	@Override
	public boolean toServer() {
		// TODO Auto-generated method stub
		return true;
	}
	
    
}
